/[MITgcm]/MITgcm/tools/genmake2
ViewVC logotype

Diff of /MITgcm/tools/genmake2

Parent Directory Parent Directory | Revision Log Revision Log | View Revision Graph Revision Graph | View Patch Patch

revision 1.73 by edhill, Tue Mar 16 18:20:34 2004 UTC revision 1.80 by edhill, Tue Jun 29 19:00:41 2004 UTC
# Line 1  Line 1 
1  #! /usr/bin/env bash  #! /usr/bin/env sh
2  #  #
3  # $Header$  # $Header$
4  #  #
# Line 67  expand_pkg_groups() { Line 67  expand_pkg_groups() {
67          done          done
68          PACKAGES=$new_packages          PACKAGES=$new_packages
69          rm -f ./p[1,2].tmp          rm -f ./p[1,2].tmp
70            return $matched
71      else      else
72          echo "Warning: can't read package groups definition file: $PKG_GROUPS"          echo "Warning: can't read package groups definition file: $PKG_GROUPS"
73      fi      fi
74  }  }
75    
76    #  Check for broken environments (eg. cygwin, MacOSX w/HFS+) that
77    #  cannot distinguish [*.F/*.F90] from [*.f/*.f90] files.
78    check_for_broken_Ff()  {
79        #  Do we have defaults for $FS and/or $FS90 ?
80        tfs=f
81        tfs9=f90
82        if test "x$FS" != x ; then
83            tfs="$FS"
84        fi
85        if test "x$FS90" != x ; then
86            tfs9="$FS90"
87        fi
88    
89        #  First check the ability to create a *.F/.f pair.
90        cat <<EOF >> genmake_hello.F
91          program hello
92          write(*,*) 'hi'
93          stop
94          end
95    EOF
96        cp genmake_hello.F "genmake_hello."$tfs > /dev/null 2>&1
97        RETVAL=$?
98        if test "x$RETVAL" != x0 ; then
99            if test "x$FS" = x ; then
100                FS='for'
101                FS90='fr9'
102                check_for_broken_Ff
103            else
104                cat <<EOF 2>&1
105    ERROR: Your file system cannot distinguish between *.F and *.f files
106      (fails the "cp" test) and this program cannot find a suitable
107      replacement extension.  Please try a different build environment or
108      contact the <MITgcm-support@mitgcm.org> list for help.
109    
110    EOF
111                exit -1
112            fi
113            return
114        fi
115        rm -f genmake_hello.*
116    
117        #  Check the ability of ${MAKE} and ${LN} to use the current set
118        #  of extensions.
119        cat <<EOF >> genmake_hello.F
120          program hello
121          write(*,*) 'hi'
122          stop
123          end
124    EOF
125        test -e Makefile  &&  mv -f Makefile Makefile.bak
126        cat <<EOF >> Makefile
127    %.$tfs : %.F
128    .SUFFIXES:
129    genmake_hello.$tfs: genmake_hello.F
130            $LN genmake_hello.F genmake_hello.$tfs
131    EOF
132        $MAKE "genmake_hello."$tfs > /dev/null 2>&1
133        RETVAL=$?
134        if test "x$RETVAL" != x0 -o ! -e "genmake_hello."$tfs ; then
135            if test "x$FS" = x ; then
136                FS='for'
137                FS90='fr9'
138                check_for_broken_Ff
139            else
140                cat <<EOF 2>&1
141    ERROR: Your file system cannot distinguish between *.F and *.f files
142      (fails the "make/ln" test) and this program cannot find a suitable
143      replacement extension.  Please try a different build environment or
144      contact the <MITgcm-support@mitgcm.org> list for help.
145    
146    EOF
147                exit -1
148                return
149            fi
150        fi
151        rm -f genmake_hello.* Makefile
152        test -e Makefile  &&  mv -f Makefile.bak Makefile
153    
154        #  If we make it here, use the extensions
155        FS=$tfs
156        FS90=$tfs9
157        return
158    }
159    
160    
161  # Guess possible config options for this host  # Guess possible config options for this host
162  find_possible_configs()  {  find_possible_configs()  {
163    
# Line 82  find_possible_configs()  { Line 168  find_possible_configs()  {
168      tmp2=`echo $tmp1 | sed -e 's/i[3-6]86/ia32/' | sed -e 's/athlon/ia32/'`      tmp2=`echo $tmp1 | sed -e 's/i[3-6]86/ia32/' | sed -e 's/athlon/ia32/'`
169      tmp3=`echo $tmp2 | sed -e 's/cray sv1/craysv1/'`      tmp3=`echo $tmp2 | sed -e 's/cray sv1/craysv1/'`
170      PLATFORM=$tmp3      PLATFORM=$tmp3
171        echo $PLATFORM | grep cygwin > /dev/null 2>&1  &&  PLATFORM=cygwin_ia32
172      OFLIST=`(cd $ROOTDIR/tools/build_options; ls | grep "^$PLATFORM")`      OFLIST=`(cd $ROOTDIR/tools/build_options; ls | grep "^$PLATFORM")`
173      echo "  The platform appears to be:  $PLATFORM"      echo "  The platform appears to be:  $PLATFORM"
174            
# Line 121  find_possible_configs()  { Line 208  find_possible_configs()  {
208      #      #
209      if test "x${MAKEDEPEND}" = x ; then      if test "x${MAKEDEPEND}" = x ; then
210        which makedepend > /dev/null 2>&1        which makedepend > /dev/null 2>&1
211        RETVAL=$?        RV0=$?
212        if test ! "x${RETVAL}" = x0 ; then        cat <<EOF >> genmake_tc.f
213          program test
214          write(*,*) 'test'
215          stop
216          end
217    EOF
218          makedepend genmake_tc.f > /dev/null 2>&1
219          RV1=$?
220          if test ! "x${RV0}${RV1}" = x00 ; then
221           echo "    a system-default makedepend was not found."           echo "    a system-default makedepend was not found."
222    
223           #  Try to build the cyrus impl           #  Try to build the cyrus impl
# Line 130  find_possible_configs()  { Line 225  find_possible_configs()  {
225           (           (
226               cd $ROOTDIR/tools/cyrus-imapd-makedepend  \               cd $ROOTDIR/tools/cyrus-imapd-makedepend  \
227                   &&  ./configure > /dev/null 2>&1  \                   &&  ./configure > /dev/null 2>&1  \
228                   &&  make > /dev/null 2>&1  \                   &&  make > /dev/null 2>&1
229                   &&  ./makedepend ifparser.c > /dev/null 2>&1  \               if test -x ./makedepend.exe ; then
230                     $LN ./makedepend.exe ./makedepend
231                 fi
232                 ./makedepend ifparser.c > /dev/null 2>&1  \
233                   &&  echo "true"                   &&  echo "true"
234           ) > ./genmake_cy_md           ) > ./genmake_cy_md
235           grep true ./genmake_cy_md > /dev/null 2>&1           grep true ./genmake_cy_md > /dev/null 2>&1
# Line 273  Usage: "$0" [OPTIONS] Line 371  Usage: "$0" [OPTIONS]
371      -help | --help | -h | --h      -help | --help | -h | --h
372            Print this help message and exit.            Print this help message and exit.
373    
374        -adoptfile NAME | --adoptfile NAME | -adof NAME | --adof NAME
375          -adoptfile=NAME | --adoptfile=NAME | -adof=NAME | --adof=NAME
376              Use "NAME" as the adoptfile.  By default, the file at
377              "tools/adjoint_options/adjoint_default" will be used.
378    
379      -nooptfile | --nooptfile      -nooptfile | --nooptfile
380        -optfile NAME | --optfile NAME | -of NAME | --of NAME        -optfile NAME | --optfile NAME | -of NAME | --of NAME
381        -optfile=NAME | --optfile=NAME | -of=NAME | --of=NAME        -optfile=NAME | --optfile=NAME | -of=NAME | --of=NAME
# Line 496  EOF Line 599  EOF
599    
600    
601  check_netcdf_libs()  {  check_netcdf_libs()  {
602      cat <<EOF > genmake_tnc.F      cat <<EOF > genmake_tnc.for
603        program fgennc        program fgennc
604  #include "netcdf.inc"  #include "netcdf.inc"
605        integer iret, ncid, xid        integer iret, ncid, xid
# Line 508  check_netcdf_libs()  { Line 611  check_netcdf_libs()  {
611        IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)        IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)
612        end        end
613  EOF  EOF
614      $CPP genmake_tnc.F > genmake_tnc.f  \      $CPP genmake_tnc.for > genmake_tnc.f  \
615          &&  $FC $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.f $LIBS >> genmake_tnc.log 2>&1          &&  $FC $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.f $LIBS >> genmake_tnc.log 2>&1
616      RET_COMPILE=$?      RET_COMPILE=$?
617      test -x ./genmake_tnc  &&  ./genmake_tnc >> genmake_tnc.log 2>&1      test -x ./genmake_tnc  &&  ./genmake_tnc >> genmake_tnc.log 2>&1
# Line 517  EOF Line 620  EOF
620          HAVE_NETCDF=t          HAVE_NETCDF=t
621      else      else
622          # try again with "-lnetcdf" added to the libs          # try again with "-lnetcdf" added to the libs
623          $CPP genmake_tnc.F > genmake_tnc.f  \          $CPP genmake_tnc.for > genmake_tnc.f  \
624              &&  $FC $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.f \              &&  $FC $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.f \
625              $LIBS -lnetcdf >> genmake_tnc_2.log 2>&1              $LIBS -lnetcdf >> genmake_tnc_2.log 2>&1
626          RET_COMPILE=$?          RET_COMPILE=$?
# Line 603  IEEE= Line 706  IEEE=
706  if test "x$MITGCM_IEEE" != x ; then  if test "x$MITGCM_IEEE" != x ; then
707      IEEE=$MITGCM_IEEE      IEEE=$MITGCM_IEEE
708  fi  fi
709    FS=
710    FS90=
711    
712  AUTODIFF_PKG_USED=f  AUTODIFF_PKG_USED=f
713  AD_OPTFILE=  AD_OPTFILE=
# Line 780  for ac_option ; do Line 885  for ac_option ; do
885          -fc=* | --fc=*)          -fc=* | --fc=*)
886              FC=$ac_optarg ;;              FC=$ac_optarg ;;
887                    
888            -fs | --fs)
889                ac_prev=FS ;;
890            -fs=* | --fs=*)
891                FS=$ac_optarg ;;
892            
893            -fs90 | --fs90)
894                ac_prev=FS90 ;;
895            -fs90=* | --fs90=*)
896                FS90=$ac_optarg ;;
897            
898          -ieee | --ieee)          -ieee | --ieee)
899              IEEE=true ;;              IEEE=true ;;
900          -noieee | --noieee)          -noieee | --noieee)
# Line 889  if test "x$OPTFILE" != xNONE ; then Line 1004  if test "x$OPTFILE" != xNONE ; then
1004      fi      fi
1005  fi  fi
1006    
1007    #  Check for broken systems that cannot correctly distinguish *.F and *.f files
1008    # check_for_broken_Ff
1009    
1010  echo "  getting AD_OPTFILE information:  "  echo "  getting AD_OPTFILE information:  "
1011  if test "x${AD_OPTFILE}" = x ; then  if test "x${AD_OPTFILE}" = x ; then
1012      if test "x$MITGCM_AD_OF" = x ; then      if test "x$MITGCM_AD_OF" = x ; then
# Line 942  if test "x$CPP" = x ; then Line 1060  if test "x$CPP" = x ; then
1060      CPP=cpp      CPP=cpp
1061  fi  fi
1062  #EH3 === UGLY ===  #EH3 === UGLY ===
1063  #  The following an ugly little hack to check for $CPP in /lib/ and it  #  The following is an ugly little hack to check for $CPP in /lib/ and
1064  #  should eventually be replaced with a more general function that  #  it should eventually be replaced with a more general function that
1065  #  searches a combo of the user's path and a list of "usual suspects"  #  searches a combo of the user's path and a list of "usual suspects"
1066  #  to find the correct location for binaries such as $CPP.  #  to find the correct location for binaries such as $CPP.
1067  for i in " " "/lib/" ; do  for i in " " "/lib/" ; do
# Line 986  EOF Line 1104  EOF
1104  fi  fi
1105  rm -f genmake_test_ln genmake_tlink  rm -f genmake_test_ln genmake_tlink
1106    
1107    #  Check for broken *.F/*.f handling and fix if possible
1108    check_for_broken_Ff
1109    
1110  if test ! "x$MPI" = x ; then  if test ! "x$MPI" = x ; then
1111        echo "  Turning on MPI cpp macros"        echo "  Turning on MPI cpp macros"
1112        DEFINES="$DEFINES -DALLOW_USE_MPI -DALWAYS_USE_MPI"        DEFINES="$DEFINES -DALLOW_USE_MPI -DALWAYS_USE_MPI"
# Line 1190  else Line 1311  else
1311              PACKAGES="$PACKAGES $i"              PACKAGES="$PACKAGES $i"
1312          done          done
1313          echo "    before group expansion packages are: $PACKAGES"          echo "    before group expansion packages are: $PACKAGES"
1314          expand_pkg_groups          while ! expand_pkg_groups; do echo > /dev/null; done
1315          echo "    after group expansion packages are:  $PACKAGES"          echo "    after group expansion packages are:  $PACKAGES"
1316      fi      fi
1317  fi  fi
1318    
1319  echo "  applying DISABLE settings"  echo "  applying DISABLE settings"
1320    for i in $PACKAGES ; do
1321        echo $i >> ./.tmp_pack
1322    done
1323    for i in `grep  "-" ./.tmp_pack` ; do
1324        j=`echo $i | sed 's/[-]//'`
1325        DISABLE="$DISABLE $j"
1326    done
1327  pack=  pack=
1328  for p in $PACKAGES ; do  for p in $PACKAGES ; do
1329      addit="t"      addit="t"
# Line 1212  PACKAGES="$pack" Line 1340  PACKAGES="$pack"
1340  echo "  applying ENABLE settings"  echo "  applying ENABLE settings"
1341  echo "" > ./.tmp_pack  echo "" > ./.tmp_pack
1342  PACKAGES="$PACKAGES $ENABLE"  PACKAGES="$PACKAGES $ENABLE"
1343    # Test if each explicitly referenced package exists
1344  for i in $PACKAGES ; do  for i in $PACKAGES ; do
1345      if test ! -d "$ROOTDIR/pkg/$i" ; then      j=`echo $i | sed 's/[-+]//'`
1346        if test ! -d "$ROOTDIR/pkg/$j" ; then
1347          echo "Error: can't find package $i at \"$ROOTDIR/pkg/$i\""          echo "Error: can't find package $i at \"$ROOTDIR/pkg/$i\""
1348          exit 1          exit 1
1349      fi      fi
1350      echo $i >> ./.tmp_pack      echo $i >> ./.tmp_pack
1351  done  done
 pack=`cat ./.tmp_pack | sort | uniq`  
 rm -f ./.tmp_pack  
1352  PACKAGES=  PACKAGES=
1353  for i in $pack ; do  for i in `grep -v "-" ./.tmp_pack | sort | uniq` ; do
1354      PACKAGES="$PACKAGES $i"      PACKAGES="$PACKAGES $i"
1355  done  done
1356    rm -f ./.tmp_pack
1357  echo "    packages are:  $PACKAGES"  echo "    packages are:  $PACKAGES"
1358    
1359  echo "  applying package dependency rules"  echo "  applying package dependency rules"
# Line 1639  cat csrclist.inc      >> $MAKEFILE Line 1768  cat csrclist.inc      >> $MAKEFILE
1768  cat f90srclist.inc    >> $MAKEFILE  cat f90srclist.inc    >> $MAKEFILE
1769  cat hlist.inc         >> $MAKEFILE  cat hlist.inc         >> $MAKEFILE
1770  cat ad_flow_files.inc >> $MAKEFILE  cat ad_flow_files.inc >> $MAKEFILE
1771  echo               >> $MAKEFILE  echo >> $MAKEFILE
1772  echo 'F77FILES =  $(SRCFILES:.F=.f)'                                           >> $MAKEFILE  echo 'F77FILES =  $(SRCFILES:.F=.'$FS')'      >> $MAKEFILE
1773  echo 'F90FILES =  $(F90SRCFILES:.F90=.f90)'                                    >> $MAKEFILE  echo 'F90FILES =  $(F90SRCFILES:.F=.'$FS90')' >> $MAKEFILE
1774  echo 'OBJFILES =  $(SRCFILES:.F=.o) $(CSRCFILES:.c=.o) $(F90SRCFILES:.F90=.o)' >> $MAKEFILE  echo 'OBJFILES =  $(SRCFILES:.F=.o) $(CSRCFILES:.c=.o) $(F90SRCFILES:.F90=.o)' >> $MAKEFILE
1775    echo >> $MAKEFILE
1776    echo '.SUFFIXES:' >> $MAKEFILE
1777    echo '.SUFFIXES: .o .F .p .'$FS' .c .F90 .'$FS90 >> $MAKEFILE
1778  rm -f srclist.inc csrclist.inc hlist.inc flist.tmp clist.tmp f90srclist.inc  rm -f srclist.inc csrclist.inc hlist.inc flist.tmp clist.tmp f90srclist.inc
1779  rm -f ad_flow_files.inc  rm -f ad_flow_files.inc
1780    
1781  cat >>$MAKEFILE <<EOF  cat >>$MAKEFILE <<EOF
1782    
 .SUFFIXES:  
 .SUFFIXES: .o .f .p .F .c .F90 .f90  
   
1783  all: \$(EXECUTABLE)  all: \$(EXECUTABLE)
1784  \$(EXECUTABLE): \$(SPECIAL_FILES) \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(OBJFILES)  \$(EXECUTABLE): \$(SPECIAL_FILES) \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(OBJFILES)
1785          @echo Creating \$@ ...          @echo Creating \$@ ...
1786          \$(LINK) -o \$@ \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) \$(LIBS)          \$(LINK) -o \$@ \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) \$(LIBS)
1787  depend:  depend:
1788          @make links          @make links
1789          \$(MAKEDEPEND) -o .f \$(DEFINES) \$(INCLUDES) \$(SRCFILES)          \$(MAKEDEPEND) -o .$FS \$(DEFINES) \$(INCLUDES) \$(SRCFILES)
1790          \$(TOOLSDIR)/f90mkdepend >> \$(MAKEFILE)          \$(TOOLSDIR)/f90mkdepend >> \$(MAKEFILE)
1791          -rm -f makedepend.out          -rm -f makedepend.out
1792    
# Line 1671  output.txt: \$(EXECUTABLE) Line 1799  output.txt: \$(EXECUTABLE)
1799          @\$(EXECUTABLE) > \$@          @\$(EXECUTABLE) > \$@
1800    
1801  clean:  clean:
1802          -rm -rf *.o *.f *.p *.f90 *.mod ${RMFILES} work.{pc,pcl} *.template          -rm -rf *.o *.$FS *.p *.$FS90 *.mod ${RMFILES} work.{pc,pcl} *.template
1803  Clean:  Clean:
1804          @make clean          @make clean
1805          @make cleanlinks          @make cleanlinks
# Line 1682  CLEAN: Line 1810  CLEAN:
1810          -find \$(EXEDIR) -name "*.meta" -exec rm {} \;          -find \$(EXEDIR) -name "*.meta" -exec rm {} \;
1811          -find \$(EXEDIR) -name "*.data" -exec rm {} \;          -find \$(EXEDIR) -name "*.data" -exec rm {} \;
1812          -find \$(EXEDIR) -name "fort.*" -exec rm {} \;          -find \$(EXEDIR) -name "fort.*" -exec rm {} \;
1813          -rm -f \$(EXECUTABLE) output.txt          -rm -f \$(EXECUTABLE) output.txt STD*
1814    
1815  #eh3 Makefile: makefile  #eh3 Makefile: makefile
1816  makefile:  makefile:
# Line 1701  FC_NAMEMANGLE.h: Line 1829  FC_NAMEMANGLE.h:
1829          @echo Creating \$@ ...          @echo Creating \$@ ...
1830          echo "$FC_NAMEMANGLE" > \$@          echo "$FC_NAMEMANGLE" > \$@
1831    
1832  # The normal chain of rules is (  .F - .f - .o  )  # The normal chain of rules is (  .F - .$FS - .o  )
1833  .F.f:  
1834    %.o : %.F
1835    
1836    .F.$FS:
1837          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
1838  .f.o:  .$FS.o:
1839          \$(FC) \$(FFLAGS) \$(FOPTIM) -c \$<          \$(FC) \$(FFLAGS) \$(FOPTIM) -c \$<
1840  .F90.f90:  .F90.$FS90:
1841          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
1842  .f90.o:  .$FS90.o:
1843          \$(F90C) \$(F90FLAGS) \$(F90OPTIM) -c \$<          \$(F90C) \$(F90FLAGS) \$(F90OPTIM) -c \$<
1844  .c.o:  .c.o:
1845          \$(CC) \$(CFLAGS) -c \$<          \$(CC) \$(CFLAGS) -c \$<
1846    
1847  # Special exceptions that use the ( .F - .p - .f - .o ) rule-chain  # Special exceptions that use the ( .F - .p - .$FS - .o ) rule-chain
1848  .F.p:  .F.p:
1849          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
1850  .p.f:  .p.$FS:
1851          \$(KPP) \$(KFLAGS1)\$@ \$(KFLAGS2) \$<          \$(KPP) \$(KFLAGS1)\$@ \$(KFLAGS2) \$<
1852    
1853  #=========================================  #=========================================
# Line 1841  for i in $KPPFILES ; do Line 1972  for i in $KPPFILES ; do
1972      if test "x$RETVAL" != x0 ; then      if test "x$RETVAL" != x0 ; then
1973          echo "Error: unable to add file \"$i\" to the exceptions list"          echo "Error: unable to add file \"$i\" to the exceptions list"
1974      fi      fi
1975      echo "$base.f: $base.p" >> $MAKEFILE      echo "$base.$FS: $base.p" >> $MAKEFILE
1976  done  done
1977    
1978  echo "  Making list of NOOPTFILES"  echo "  Making list of NOOPTFILES"
# Line 1851  for i in $NOOPTFILES ; do Line 1982  for i in $NOOPTFILES ; do
1982      if test "x$RETVAL" != x0 ; then      if test "x$RETVAL" != x0 ; then
1983          echo "Error: unable to add file \"$i\" to the exceptions list"          echo "Error: unable to add file \"$i\" to the exceptions list"
1984      fi      fi
1985      echo "$base.o: $base.f" >> $MAKEFILE      echo "$base.o: $base.$FS" >> $MAKEFILE
1986      printf "\t\$(FC) \$(FFLAGS) \$(NOOPTFLAGS) -c \$<\n" >> $MAKEFILE      printf "\t\$(FC) \$(FFLAGS) \$(NOOPTFLAGS) -c \$<\n" >> $MAKEFILE
1987  done  done
1988    

Legend:
Removed from v.1.73  
changed lines
  Added in v.1.80

  ViewVC Help
Powered by ViewVC 1.1.22